# change the distro and perl defines to reflect the version of RedHat and perl
# you are building the rpm for.
%define distro rh73
%define perl 5.6.1

Summary: PCXperience Firewall Scripts
Name: pcxfirewall
Version: 2.22
Release: 1.%{distro}
Copyright: GPL
Group: Applications/Firewall
Source0: pcxfirewall-%{version}.tar.gz
Source1: libpcxfirewall-perl-%{version}.tar.gz
URL: http://pcxfirewall.sourceforge.net/
Vendor: Xperience, Inc.
Packager: James A. Pattie <james@pcxperience.com>
BuildRoot: /var/tmp/pcxfirewall-%{version}-buildroot/
BuildRequires: perl = %{perl}
Requires: perl = %{perl}, iptables, kernel >= 2.4.5, chkconfig
Conflicts: pcx_firewall

%description
The pcx_firewall scripts provide a programming API in perl using OO modules to
access the iptables features of the 2.4.x linux kernels.  Run perldoc
PCXFireWall::Module to see the POD documentation for Module.  Or you can look at
the man pages in the documentation directory.

Run '/usr/lib/pcx_firewall/generator' after customizing the configuration
methods in '/usr/lib/pcx_firewall/PCXFireWall/Rules.pm'.  This will create a
script called 'firewall' which is the actual firewall script.

Run '/usr/lib/pcx_firewall/install' to put the script in the final location
which is /etc/pcx_firewall.  Your previous script will be backed up before
the new script is put in place.

Or you can put 'firewall' in /etc/init.d if you generated using option '-s init'
to create an init script.  You will then need to make init aware of your 
firewall script via the 'chkconfig firewall on' and then start it by 'service 
firewall start' commands.

Make sure that the ipchains service is not running otherwise firewall will
not start.  You should also disable the iptables service.

%prep
%setup -q

%build
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
cp %{SOURCE1} .
./install -p $RPM_BUILD_ROOT -r

%clean
rm -rf $RPM_BUILD_ROOT

%install
[ -x /usr/lib/rpm/brp-compress ] && /usr/lib/rpm/brp-compress

find $RPM_BUILD_ROOT/ -type f -print |
  sed "s@^$RPM_BUILD_ROOT@@g" |
  grep -v perllocal.pod |
  grep -v "/usr/lib/pcx_firewall/generator" |
  grep -v "/usr/lib/pcx_firewall/install" |
  grep -v "/etc/pcx_firewall/dynamic_rules.sh.ex" |
  grep -v "\.packlist" > pcxfirewall-%{version}-filelist
if [ "$(cat pcxfirewall-%{version}-filelist)X" = "X" ]; then
  echo "ERROR: EMPTY FILE LIST"
  exit -1
fi

%preun
if [ $1 = 0 ]; then
  # we are being deleted, not upgraded
  chkconfig iptables on
  chkconfig --del iptables.pcx
fi

%post
chkconfig ipchains off
chkconfig iptables off
chkconfig --del iptables.pcx 
echo "You need to install the Rules Modules to create anything."

%files -f pcxfirewall-%{version}-filelist
%defattr(-,root,root)
%dir /usr/lib/pcx_firewall
%attr(0755, root, root) /usr/lib/pcx_firewall/generator
%attr(0755, root, root) /usr/lib/pcx_firewall/install
%dir /usr/lib/pcx_firewall/PCXFireWall
%doc README
%doc README.dynamic_rules
%doc docs/Template.pm
%doc docs/manpages.html
%doc docs/toolkit_howto.html
%doc docs/toolkit_howto2.html
%doc docs/man/
%dir /usr/lib/pcx_firewall/output
%dir /etc/pcx_firewall
%config /etc/pcx_firewall/dynamic_rules.sh.ex

%changelog
* Tue Aug 12 2003 James A. Pattie <james@pcxperience.com> - 2.22-1.rh73
- Version 2.22 - Cleaned up the dynamic_rules.sh example file location.

* Tue Aug 12 2003 James A. Pattie <james@pcxperience.com> - 2.21-2
- Updated to take into account the new name change pcx_firewall -> pcxfirewall.

* Fri Feb 14 2003 James A. Pattie <james@pcxperience.com>
- Version 2.21 - Added dynamic script support to the init script.

* Tue Dec 31 2002 James A. Pattie <james@pcxperience.com>
- Version 2.20 - We no longer write directly to the file, but into a string
  which is only output to the file after everything worked.

* Tue Dec 10 2002 James A. Pattie <james@pcxperience.com>
- Version 2.19 - Made the IP Address and BroadCast Address lookup code be
  via shell functions.  Took into account IP Aliases and the ip command.

* Thu Nov 07 2002 James A. Pattie <james@pcxperience.com>
- Version 2.18 - Fixed bug in shell function.

* Wed Aug 21 2002 James A. Pattie <james@pcxperience.com>
- Version 2.17 - Generated code cleanups.

* Wed May 29 2002 James A. Pattie <james@pcxperience.com>
- Version 2.16 - Fixed the Mangles table checks.

* Tue Apr 09 2002 James A. Pattie <james@pcxperience.com>
- Version 2.14 - Added the insmod Modules support.

* Mon Apr 01 2002 James A. Pattie <james@pcxperience.com>
- Version 2.13 - Fixed up some IPv6 issues.  Made the startup script output
  Success/Failure messages for the start and stop actions.

* Sat Mar 02 2002 James A. Pattie <james@pcxperience.com>
- Version 2.12 - Fleshing out any matches and Targets that were not included
  in the previous versions.

* Thu Dec 27 2001 James A. Pattie <james@pcxperience.com>
- Version 2.11 - Moved the core modules into the Perl tree. Moved the Rules.pm 
  module into the Rules Package as it is now being maintained in the PCXFirewall
  Rules module.

* Thu Nov 29 2001 James A. Pattie <james@pcxperience.com>
- Version 2.10 - Removed the VeryTightStatic module as it is now being 
  maintained in the PCXFirewall Rules module.

* Thu Nov 15 2001 James A. Pattie <james@pcxperience.com>
- Version 2.9 - Major changes in how rules are generated and the ordering that
  generator outputs rules and /proc entries in.  See README and changelog in
  generator for more details.

* Wed Nov 07 2001 James A. Pattie <james@pcxperience.com>
- Version 2.8 - Major change in how /proc is handled.  Other cleanups and
  enhancements were also done.  We now support the use of ip instead of just
  ifconfig to determine dynamic IP Addresses.  Added 
  /etc/rc.d/init.d/iptables.pcx service script which will run the firewall 
  startfw and stopfw scripts.  It is based off of RedHat's script.

* Wed Oct 03 2001 James A. Pattie <james@pcxperience.com>
- Version 2.7 - Changed the layout of the documentation files to clean things
  up for the import into SF cvs.  Updated install script to handle naming the
  copied scripts after the rules module they were generated from.

* Sat Sep 08 2001 James A. Pattie <james@pcxperience.com>
- Version 2.6 - Fixed the file permission problem when generating files.
  Updated the install script to have better argument support and have a verbose
  option so you can see what is happening.  Updated Rules.pm.

* Sat Jul 14 2001 James A. Pattie <james@pcxperience.com>
- Version 2.5 - Removed the protocol check for reject so that it can be
  used for any protocol.  Pointed out by Arne Bernin.

* Sat Jul 14 2001 James A. Pattie <james@pcxperience.com>
- Version 2.4 - If building the scripts off a custom rules file the
  resulting scripts are placed in a directory with the same name as
  the rules file being used (without the .pm ending of course).
  The install script is now able to pull the scripts from a specified
  directory using -s sourcedir or it will pull from output if no
  directory is specified.

* Sat Jun 16 2001 James A. Pattie <james@pcxperience.com>
- Version 2.3:
  Made locations be customizable.
  Any of the antiSpoofing, logMartians, icmpRedirects, sourceRouting methods
    can now have the interface defined to enable/disable or apply to all
    interfaces (like it previously did).
  limitting log and it's parent rules are now seperate things.  You can specify
    a rule which will log and only limit the log, the rule or neither/both via
    the parameters you specify.  See NOTE in the man pages.

* Fri Apr 27 2001 James A. Pattie <james@pcxperience.com>
- Version 2.2 - Rule fixes (bootp)
- Added optional "Rules" command line argument to use when running generator.
- Created Template.pm which is a stripped down version of Rules.pm and is
  stored in the doc directory.  Used to allow the user to have multiple rulesets
  defined for use by generator.

* Sat Apr 21 2001 James A. Pattie <james@pcxperience.com>
- Version 2.1 - minor bug fixes and improvements in error generation code.
- Updated the default Rules to be a better template and fixed simple error
  in FORWARD chain allow code.  It was looking at the wrong interface.
- Added error checking for length of chain and log-prefix values.
- Moved some rules around so that they don't match too soon.
- Fixed the Squid allow rules.
- Changed the URL for the project in the rpm.
- Added some very important policy settings to stoppingRules.
- Fleshed out some more generic protocols for INPUT.

* Thu Apr 19 2001 James A. Pattie <james@pcxperience.com>
- Version 2.0 - Redesigned the firewall configuration to be a perl API which 
  provides easier "design" and "programming" of an iptables firewall. 

- Updated the Rules so that ICMP traffic is allowed to reach the firewall.

- Updated the Rules so that the LOG rules had limits turned on.

- Made the log-prefix value be at most 29 characters.
